**********************************************************************
*                                                                    *
*     REAXFF Reactive force field program                            *
*                                                                    *
*     Developed and written by Adri van Duin, duin@wag.caltech.edu   *
*                                                                    *
*     Copyright (c) 2001-2010 California Institute of Technology     *
*                                                                    *
*     This is an open-source program. Feel free to modify its        *
*     contents. Please keep me informed of any useful modification   *
*     or addition that you made. Please do not distribute this       *
*     program to others; if people are interested in obtaining       *
*     a copy of this program let them contact me first.              *
*                                                                    *
********************************************************************** 
********************************************************************** 

      subroutine getswb(swb_tmp)

********************************************************************** 
#include "cbka.blk"
#include "cbkff.blk"
      real*8 swb_tmp

********************************************************************** 
*                                                                    *
*     Report the value of swb                                        *
*                                                                    *
********************************************************************** 

      swb_tmp = swb

      return
      end

********************************************************************** 

      subroutine getswa(swa_tmp)

********************************************************************** 
#include "cbka.blk"
#include "cbkff.blk"
      real*8 swa_tmp

********************************************************************** 
*                                                                    *
*     Report the value of swa                                        *
*                                                                    *
********************************************************************** 

      swa_tmp = swa

      return
      end

********************************************************************** 

      subroutine getvrange(vrange_tmp)

********************************************************************** 
#include "cbka.blk"
#include "control.blk"
      real*8 vrange_tmp

********************************************************************** 
*                                                                    *
*     Report the value of vrange                                     *
*                                                                    *
********************************************************************** 

      vrange_tmp = vrange

      return
      end

********************************************************************** 

      subroutine getnvlist(nvlist_tmp)

********************************************************************** 
#include "cbka.blk"
      integer nvlist_tmp

********************************************************************** 
*                                                                    *
*     Report the value of nvlist                                     *
*                                                                    *
********************************************************************** 

      nvlist_tmp = nvlist

      return
      end

********************************************************************** 

      subroutine getvlbora(vlbora_tmp)

********************************************************************** 
#include "cbka.blk"
#include "control.blk"
      real*8 vlbora_tmp

********************************************************************** 
*                                                                    *
*     Report the value of vlbora                                        *
*                                                                    *
********************************************************************** 

      vlbora_tmp = vlbora

      return
      end

********************************************************************** 

      subroutine getnval(nval_tmp)

********************************************************************** 
#include "cbka.blk"
#include "cbkvalence.blk"
      integer nval_tmp

********************************************************************** 
*                                                                    *
*     Report the value of nval                                       *
*                                                                    *
********************************************************************** 

      nval_tmp = nval

      return
      end

********************************************************************** 

      subroutine getntor(ntor_tmp)

********************************************************************** 
#include "cbka.blk"
#include "cbktorsion.blk"
      integer ntor_tmp

********************************************************************** 
*                                                                    *
*     Report the value of ntor                                       *
*                                                                    *
********************************************************************** 

      ntor_tmp = ntor

      return
      end


********************************************************************** 

      subroutine getnhb(nhb_tmp)

********************************************************************** 
#include "cbka.blk"
#include "cbksrthb.blk"
      integer nhb_tmp

********************************************************************** 
*                                                                    *
*     Report the value of nhb                                       *
*                                                                    *
********************************************************************** 

      nhb_tmp = nhb

      return
      end


********************************************************************** 

      subroutine getnbonall(nbonall_tmp)

********************************************************************** 
#include "cbka.blk"
#include "cbksrtbon1.blk"
      integer nbonall_tmp

********************************************************************** 
*                                                                    *
*     Report the value of nbonall                                    *
*                                                                    *
********************************************************************** 

      nbonall_tmp = nbonall

      return
      end


********************************************************************** 

      subroutine getnneighmax(nneighmax_tmp)

********************************************************************** 
#include "cbka.blk"
      integer nneighmax_tmp

********************************************************************** 
*                                                                    *
*     Report the value of nneighmax                                       *
*                                                                    *
********************************************************************** 

      nneighmax_tmp = nneighmax

      return
      end

********************************************************************** 

      subroutine getnat(nat_tmp)

********************************************************************** 
#include "cbka.blk"
      integer nat_tmp

********************************************************************** 
*                                                                    *
*     Report the value of nat                                       *
*                                                                    *
********************************************************************** 

      nat_tmp = nat

      return
      end

********************************************************************** 

      subroutine getnattot(nattot_tmp)

********************************************************************** 
#include "cbka.blk"
      integer nattot_tmp

********************************************************************** 
*                                                                    *
*     Report the value of nattot                                       *
*                                                                    *
********************************************************************** 

      nattot_tmp = nattot

      return
      end

********************************************************************** 

      subroutine getnsort(nsort_tmp)

********************************************************************** 
#include "cbka.blk"
      integer nsort_tmp

********************************************************************** 
*                                                                    *
*     Report the value of nsort                                       *
*                                                                    *
********************************************************************** 

      nsort_tmp = nsort 

      return
      end

********************************************************************** 

      subroutine getmbond(mbond_tmp)

********************************************************************** 
#include "cbka.blk"
      integer mbond_tmp

********************************************************************** 
*                                                                    *
*     Report the value of mbond                                       *
*                                                                    *
********************************************************************** 

      mbond_tmp = mbond 

      return
      end

********************************************************************** 

      subroutine getnso(nso_tmp)

********************************************************************** 
#include "cbka.blk"
#include "cbkff.blk"
      integer nso_tmp

********************************************************************** 
*                                                                    *
*     Report the value of nso                                        *
*                                                                    *
********************************************************************** 

      nso_tmp = nso

      return
      end


********************************************************************** 

      subroutine setngeofor(ngeofor_tmp)

********************************************************************** 
#include "cbka.blk"
#include "control.blk"
      integer ngeofor_tmp

********************************************************************** 
*                                                                    *
*     Set value of ngeofor
*                                                                    *
********************************************************************** 

      ngeofor = ngeofor_tmp
      return
      end

**********************************************************************
 
      subroutine getnsbmax(nsbmax_tmp)
 
**********************************************************************
#include "cbka.blk"
#include "cbksrtbon1.blk"
      integer nsbmax_tmp
 
**********************************************************************
*                                                                    *
*     Report the value of nsbmax                                     *
*                                                                    *
**********************************************************************
 
      nsbmax_tmp = nsbmax
 
      return
      end
 
**********************************************************************
 
      subroutine getnsbma2(nsbma2_tmp)
 
**********************************************************************
#include "cbka.blk"
#include "cbksrtbon1.blk"
      integer nsbma2_tmp
 
**********************************************************************
*                                                                    *
*     Report the value of nsbma2                                     *
*                                                                    *
**********************************************************************
 
      nsbma2_tmp = nsbma2
 
      return
      end
 
**********************************************************************
 
      subroutine getcutof3(cutof3_tmp)
 
**********************************************************************
#include "cbka.blk"
#include "control.blk"
      real*8 cutof3_tmp
 
**********************************************************************
*                                                                    *
*     Report the value of cutof3                                     *
*                                                                    *
**********************************************************************
 
      cutof3_tmp = cutof3
 
      return
      end

